Attribute VB_Name = "basProductAkt_CryptProgCode"
Public Function ProductCode(code As String) As String
  Dim lProductCode As Long, i As Integer

  For i = 1 To Len(code) 'Quelle muss bei Auswertung angegeben werden
    lProductCode = lProductCode + Asc(Mid$(code, i, 5))
  Next i
  
  ProductCode = (Hex(lProductCode))
End Function

Public Function ProgCodeProf(ProgCode As String) As String
' Erstellt einen Code, bei dem nach jedem 5. Zeichen ein Bindestrich gesetzt wird
Dim MakeCode As String
For i = 1 To Len(ProgCode)
If i Mod 5 = 0 Then
MakeCode = MakeCode & Mid(ProgCode, i, 1) & "-"
Else
MakeCode = MakeCode & Mid(ProgCode, i, 1)
End If
Next
If Right(MakeCode, 1) = "-" Then
        MakeCode = Mid(MakeCode, 1, (Len(MakeCode) - 1)) ' Wenn letztes Zeichen ein Bindestrich ist, dann weglschen
Else
        MakeCode = Mid(MakeCode, 1, Len(MakeCode)) ' Letztes Zeichen war kein Bindestrich, also alles beibehalten
End If
        
ProgCodeProf = MakeCode ' bergibt den fertigen Code an die Funktion
End Function

Public Function MakeProductID(sUserName As String, sFirma As String, sEmail As String) As String
Dim PCData
Dim UserData

        'Generiert die Produkt-ID
        PCData = GetVolSerialNo("C:") & GetWindowsVersion & App.EXEName & App.Minor & App.LegalCopyright & App.Major & App.ProductName & App.Revision & App.Path
        UserData = sUserName & sFirma & sEmail
MakeProductID = ProgCodeProf(SecureHash(PCData & UserData))
End Function

Public Function MakeActivationKey(sProductID As String) As String
Dim CryptedKey As String
Dim i As Long
Dim NewChar As Long

'bergibt den Wert einer Variablen
CryptedKey = sProductID
    
    'Generiert den Aktivierungsschlssel
    i = 1
    Do Until i = Len(sProductID) + 1
        NewChar = Asc(Mid(sProductID, i, 1)) + 13
        CryptedKey = CryptedKey + Chr(NewChar)
        i = i + 1
    Loop

MakeActivationKey = ProgCodeProf(SecureHash(CryptedKey))
End Function
