Attribute VB_Name = "basProductAkt_HDDSerial"
' Seriennumer des angegebenen Laufwerks ermitteln
Public Function GetVolSerialNo(ByVal sDrive As String) As Long
  Dim sComputer As String
  Dim oWMI As Object
  Dim oDrives As Object
  Dim oDrive As Object

  ' Fehlerbehandlung aktivieren
  On Error GoTo ErrHandler

  sDrive = UCase$(sDrive)
  If Len(sDrive) > 2 Then sDrive = Left$(sDrive, 2)
  If Right$(sDrive, 1) <> ":" Then sDrive = sDrive & ":"

  ' aktuelles System
  sComputer = "."

  ' WMI-Objekt erstellen
  Set oWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" _
    & sComputer & "\root\cimv2")

  ' WMI-Abfrage erstellen
  Set oDrives = oWMI.ExecQuery("Select * from Win32_LogicalDisk WHERE DeviceID='" & sDrive & "'")
  
  For Each oDrive In oDrives
    ' SerialNo von HEX-Darstellung nach Long-Wert umwandeln
    GetVolSerialNo = CLng("&H" & oDrive.VolumeSerialNumber)
    Exit For
  Next
  On Error GoTo 0
  Exit Function

ErrHandler:
  ' Fehler!
  ' Entweder kein WMI installiert oder ungltige Laufwerksangabe
  On Error GoTo 0
End Function

